Index: channels/chan_skinny.c
===================================================================
--- channels/chan_skinny.c	(revision 92855)
+++ channels/chan_skinny.c	(working copy)
@@ -1427,7 +1427,7 @@
 			/* This is a match, since we're checking for line on every device. */
 		} else if (!strcasecmp(d->name, device)) {
 			if (skinnydebug)
-				ast_verbose(VERBOSE_PREFIX_2 "Found device: %s\n", d->name);
+				ast_verbose(2, "Found device: %s\n", d->name);
 		} else
 			continue;
 
@@ -1436,7 +1436,7 @@
 			/* Search for the right line */
 			if (!strcasecmp(l->name, line)) {
 				if (tmpl) {
-					ast_verbose(VERBOSE_PREFIX_2 "Ambiguous line name: %s\n", line);
+					ast_verb(2, "Ambiguous line name: %s\n", line);
 					ast_mutex_unlock(&devicelock);
 					return NULL;
 				} else
Index: apps/app_chanspy.c
===================================================================
--- apps/app_chanspy.c	(revision 92855)
+++ apps/app_chanspy.c	(working copy)
@@ -369,8 +369,7 @@
 	ast_audiohook_unlock(&csth.spy_audiohook);
 	ast_audiohook_destroy(&csth.spy_audiohook);
 	
-	if (option_verbose >= 2)
-		ast_verbose(VERBOSE_PREFIX_2 "Done Spying on channel %s\n", name);
+	ast_verb(2, "Done Spying on channel %s\n", name);
 	
 	return running;
 }
Index: apps/app_mixmonitor.c
===================================================================
--- apps/app_mixmonitor.c	(revision 92855)
+++ apps/app_mixmonitor.c	(working copy)
@@ -141,8 +141,7 @@
 	char *ext;
 	int errflag = 0;
 
-	if (option_verbose > 1)
-		ast_verbose(VERBOSE_PREFIX_2 "Begin MixMonitor Recording %s\n", mixmonitor->name);
+	ast_verb(2, "Begin MixMonitor Recording %s\n", mixmonitor->name);
 	
 	ast_audiohook_lock(&mixmonitor->audiohook);
 
@@ -188,15 +187,13 @@
 	ast_audiohook_unlock(&mixmonitor->audiohook);
 	ast_audiohook_destroy(&mixmonitor->audiohook);
 
-	if (option_verbose > 1)
-		ast_verbose(VERBOSE_PREFIX_2 "End MixMonitor Recording %s\n", mixmonitor->name);
+	ast_verb(2, "End MixMonitor Recording %s\n", mixmonitor->name);
 
 	if (fs)
 		ast_closestream(fs);
 
 	if (mixmonitor->post_process) {
-		if (option_verbose > 2)
-			ast_verbose(VERBOSE_PREFIX_2 "Executing [%s]\n", mixmonitor->post_process);
+		ast_verb(2, "Executing [%s]\n", mixmonitor->post_process);
 		ast_safe_system(mixmonitor->post_process);
 	}
 
Index: apps/app_minivm.c
===================================================================
--- apps/app_minivm.c	(revision 92855)
+++ apps/app_minivm.c	(working copy)
@@ -1256,8 +1256,7 @@
 		switch (cmd) {
  		case '2':
  			/* Review */
- 			if (option_verbose > 2)
-				ast_verbose(VERBOSE_PREFIX_3 "Reviewing the message\n");
+			ast_verb(3, "Reviewing the message\n");
  			ast_streamfile(chan, recordfile, chan->language);
  			cmd = ast_waitstream(chan, AST_DIGIT_ANY);
  			break;
@@ -1266,9 +1265,9 @@
  			/* Record */
 			if (option_verbose > 2) {
  				if (recorded == 1) 
-					ast_verbose(VERBOSE_PREFIX_3 "Re-recording the message\n");
+					ast_verb(3, "Re-recording the message\n");
  				else
-					ast_verbose(VERBOSE_PREFIX_3 "Recording the message\n");
+					ast_verb(3, "Recording the message\n");
 			}
 			if (recorded && outsidecaller) 
  				cmd = ast_play_and_wait(chan, "beep");
@@ -1571,8 +1570,7 @@
 		}
 
 		if (duration < global_vmminmessage) {
-			if (option_verbose > 2) 
-				ast_verbose( VERBOSE_PREFIX_3 "Recording was %d seconds long but needs to be at least %d - abandoning\n", duration, global_vmminmessage);
+			ast_verb(3, "Recording was %d seconds long but needs to be at least %d - abandoning\n", duration, global_vmminmessage);
 			fclose(txt);
 			ast_filedelete(tmptxtfile, NULL);
 			unlink(tmptxtfile);
Index: apps/app_voicemail.c
===================================================================
--- apps/app_voicemail.c	(revision 92855)
+++ apps/app_voicemail.c	(working copy)
@@ -6743,8 +6743,7 @@
 			if (chan->cid.cid_num) {
 				ast_copy_string(mailbox, chan->cid.cid_num, mailbox_size);
 			} else {
-				if (option_verbose > 2)
-					ast_verbose(VERBOSE_PREFIX_3 "Username not entered\n");	
+				ast_verb(3,"Username not entered\n");	
 				return -1;
 			}
 		}
@@ -8929,8 +8928,7 @@
 				char mailbox[AST_MAX_EXTENSION * 2 + 2];
 				snprintf(mailbox, sizeof(mailbox), "%s@%s", num, vmu->context);
 
-				if (option_verbose > 2)
-					ast_verbose(VERBOSE_PREFIX_3 "Leaving voicemail for '%s' in context '%s'\n", num, vmu->context);
+				ast_verb(3, "Leaving voicemail for '%s' in context '%s'\n", num, vmu->context);
 				
 				memset(&leave_options, 0, sizeof(leave_options));
 				leave_options.record_gain = record_gain;
@@ -9005,8 +9003,7 @@
 				break;
 			} else {
 				/* Otherwise 1 is to save the existing message */
-				if (option_verbose > 2)
-					ast_verbose(VERBOSE_PREFIX_3 "Saving message as is\n");
+				ast_verb(3, "Saving message as is\n");
 				if (!outsidecaller) 
 					ast_filerename(tempfile, recordfile, NULL);
 				ast_stream_and_wait(chan, "vm-msgsaved", "");
@@ -9019,20 +9016,17 @@
 			}
 		case '2':
 			/* Review */
-			if (option_verbose > 2)
-				ast_verbose(VERBOSE_PREFIX_3 "Reviewing the message\n");
+			ast_verb(3, "Reviewing the message\n");
 			cmd = ast_stream_and_wait(chan, tempfile, AST_DIGIT_ANY);
 			break;
 		case '3':
 			message_exists = 0;
 			/* Record */
-			if (recorded == 1) {
-				if (option_verbose > 2)
-					ast_verbose(VERBOSE_PREFIX_3 "Re-recording the message\n");
-			} else {	
-				if (option_verbose > 2)
-					ast_verbose(VERBOSE_PREFIX_3 "Recording the message\n");
-			}
+			if (recorded == 1) 
+				ast_verb(3, "Re-recording the message\n");
+			else	
+				ast_verb(3, "Recording the message\n");
+			
 			if (recorded && outsidecaller) {
 				cmd = ast_play_and_wait(chan, INTRO);
 				cmd = ast_play_and_wait(chan, "beep");
Index: apps/app_dial.c
===================================================================
--- apps/app_dial.c	(revision 92855)
+++ apps/app_dial.c	(working copy)
@@ -1148,18 +1148,15 @@
 
 	if (strncmp(pa->privcid, "NOCALLERID", 10) != 0 && ast_test_flag64(opts, OPT_SCREEN_NOCLID)) {
 		/* if callerid is set, and OPT_SCREEN_NOCLID is set also */  
-		if (option_verbose > 2)
-			ast_verbose(VERBOSE_PREFIX_3  "CallerID set (%s); N option set; Screening should be off\n", pa->privcid);
+		ast_verb(3, "CallerID set (%s); N option set; Screening should be off\n", pa->privcid);
 		pa->privdb_val = AST_PRIVACY_ALLOW;
 	} else if (ast_test_flag64(opts, OPT_SCREEN_NOCLID) && strncmp(pa->privcid, "NOCALLERID", 10) == 0 ) {
-		if (option_verbose > 2)
-			ast_verbose(VERBOSE_PREFIX_3  "CallerID blank; N option set; Screening should happen; dbval is %d\n", pa->privdb_val);
+		ast_verb(3, "CallerID blank; N option set; Screening should happen; dbval is %d\n", pa->privdb_val);
 	}
 	
 	if (pa->privdb_val == AST_PRIVACY_DENY) {
 		ast_copy_string(pa->status, "NOANSWER", sizeof(pa->status));
-		if (option_verbose > 2)
-			ast_verbose(VERBOSE_PREFIX_3  "Privacy DB reports PRIVACY_DENY for this callerid. Dial reports unavailable\n");
+		ast_verb(3, "Privacy DB reports PRIVACY_DENY for this callerid. Dial reports unavailable\n");
 		return 0;
 	} else if (pa->privdb_val == AST_PRIVACY_KILL) {
 		ast_copy_string(pa->status, "DONTCALL", sizeof(pa->status));
@@ -1769,13 +1766,11 @@
 				peer->whentohangup = time(NULL) + calldurationlimit;
 			}
 			if (!ast_strlen_zero(dtmfcalled)) { 
-				if (option_verbose > 2)
-					ast_verbose(VERBOSE_PREFIX_3 "Sending DTMF '%s' to the called party.\n", dtmfcalled);
+				ast_verb(3, "Sending DTMF '%s' to the called party.\n", dtmfcalled);
 				res = ast_dtmf_stream(peer, chan, dtmfcalled, 250, 0);
 			}
 			if (!ast_strlen_zero(dtmfcalling)) {
-				if (option_verbose > 2)
-					ast_verbose(VERBOSE_PREFIX_3 "Sending DTMF '%s' to the calling party.\n", dtmfcalling);
+				ast_verb(3, "Sending DTMF '%s' to the calling party.\n", dtmfcalling);
 				res = ast_dtmf_stream(chan, peer, dtmfcalling, 250, 0);
 			}
 		}
Index: apps/app_amd.c
===================================================================
--- apps/app_amd.c	(revision 92855)
+++ apps/app_amd.c	(working copy)
@@ -199,8 +199,7 @@
 			framelength = (ast_codec_get_samples(f) / DEFAULT_SAMPLES_PER_MS);
 			iTotalTime += framelength;
 			if (iTotalTime >= totalAnalysisTime) {
-				if (option_verbose > 2)	
-					ast_verbose(VERBOSE_PREFIX_3 "AMD: Channel [%s]. Too long...\n", chan->name );
+				ast_verb(3, "AMD: Channel [%s]. Too long...\n", chan->name );
 				ast_frfree(f);
 				strcpy(amdStatus , "NOTSURE");
 				sprintf(amdCause , "TOOLONG-%d", iTotalTime);
@@ -216,16 +215,14 @@
 				if (silenceDuration >= betweenWordsSilence) {
 					if (currentState != STATE_IN_SILENCE ) {
 						previousState = currentState;
-						if (option_verbose > 2)
-							ast_verbose(VERBOSE_PREFIX_3 "AMD: Changed state to STATE_IN_SILENCE\n");
+						ast_verb(3, "AMD: Changed state to STATE_IN_SILENCE\n");
 					}
 					currentState  = STATE_IN_SILENCE;
 					consecutiveVoiceDuration = 0;
 				}
 				
 				if (inInitialSilence == 1  && silenceDuration >= initialSilence) {
-					if (option_verbose > 2)
-						ast_verbose(VERBOSE_PREFIX_3 "AMD: ANSWERING MACHINE: silenceDuration:%d initialSilence:%d\n",
+					ast_verb(3, "AMD: ANSWERING MACHINE: silenceDuration:%d initialSilence:%d\n",
 							    silenceDuration, initialSilence);
 					ast_frfree(f);
 					strcpy(amdStatus , "MACHINE");
@@ -250,15 +247,13 @@
 				   number of words if my previous state was Silence, which means that I moved into a word. */
 				if (consecutiveVoiceDuration >= minimumWordLength && currentState == STATE_IN_SILENCE) {
 					iWordsCount++;
-					if (option_verbose > 2)
-						ast_verbose(VERBOSE_PREFIX_3 "AMD: Word detected. iWordsCount:%d\n", iWordsCount);
+					ast_verb(3, "AMD: Word detected. iWordsCount:%d\n", iWordsCount);
 					previousState = currentState;
 					currentState = STATE_IN_WORD;
 				}
 				
 				if (iWordsCount >= maximumNumberOfWords) {
-					if (option_verbose > 2)
-						ast_verbose(VERBOSE_PREFIX_3 "AMD: ANSWERING MACHINE: iWordsCount:%d\n", iWordsCount);
+					ast_verb(3, "AMD: ANSWERING MACHINE: iWordsCount:%d\n", iWordsCount);
 					ast_frfree(f);
 					strcpy(amdStatus , "MACHINE");
 					sprintf(amdCause , "MAXWORDS-%d-%d", iWordsCount, maximumNumberOfWords);
Index: main/asterisk.c
===================================================================
--- main/asterisk.c	(revision 92855)
+++ main/asterisk.c	(working copy)
@@ -986,8 +986,7 @@
 				break;
 		}
 	}
-	if (option_verbose > 2) 
-		ast_verbose(VERBOSE_PREFIX_3 "Remote UNIX connection disconnected\n");
+	ast_verb(3, "Remote UNIX connection disconnected\n");
 	close(con->fd);
 	close(con->p[0]);
 	close(con->p[1]);
@@ -1050,10 +1049,8 @@
 				fdprint(s, "No more connections allowed\n");
 				ast_log(LOG_WARNING, "No more connections allowed\n");
 				close(s);
-			} else if (consoles[x].fd > -1) {
-				if (option_verbose > 2) 
-					ast_verbose(VERBOSE_PREFIX_3 "Remote UNIX connection\n");
-			}
+			} else if (consoles[x].fd > -1) 
+				ast_verb(3, "Remote UNIX connection\n");
 		}
 	}
 	return NULL;
Index: main/pbx.c
===================================================================
--- main/pbx.c	(revision 92855)
+++ main/pbx.c	(working copy)
@@ -3294,8 +3294,7 @@
 				if ((res == AST_PBX_ERROR) && ast_exists_extension(c, c->context, "e", 1, c->cid.cid_num)) {
 					/* if we are already on the 'e' exten, don't jump to it again */
 					if (!strcmp(c->exten, "e")) {
-						if (option_verbose > 1)
-							ast_verbose(VERBOSE_PREFIX_2 "Spawn extension (%s, %s, %d) exited ERROR while already on 'e' exten on '%s'\n", c->context, c->exten, c->priority, c->name);
+						ast_verb(2, "Spawn extension (%s, %s, %d) exited ERROR while already on 'e' exten on '%s'\n", c->context, c->exten, c->priority, c->name);
 						error = 1;
 					} else {
 						pbx_builtin_raise_exception(c, "ERROR");
Index: main/netsock.c
===================================================================
--- main/netsock.c	(revision 92855)
+++ main/netsock.c	(working copy)
@@ -149,18 +149,14 @@
 	
 	if ((res = setsockopt(netsocket, IPPROTO_IP, IP_TOS, &tos, sizeof(tos))))
 		ast_log(LOG_WARNING, "Unable to set TOS to %d\n", tos);
-	else {
-	    if (option_verbose > 1)
-		ast_verbose(VERBOSE_PREFIX_2 "Using TOS bits %d\n", tos);
-	}
+	else 
+		ast_verb(2, "Using TOS bits %d\n", tos);
 
 #if defined(linux)								
 	if (setsockopt(netsocket, SOL_SOCKET, SO_PRIORITY, &cos, sizeof(cos)))
-	    ast_log(LOG_WARNING, "Unable to set CoS to %d\n", cos);
-	else {
-	    if (option_verbose > 1)
-		ast_verbose(VERBOSE_PREFIX_2 "Using CoS mark %d\n", cos);
-	}
+		ast_log(LOG_WARNING, "Unable to set CoS to %d\n", cos);
+	else
+		ast_verb(2, "Using CoS mark %d\n", cos);
 #endif
 							
 	return res;
Index: main/srv.c
===================================================================
--- main/srv.c	(revision 92855)
+++ main/srv.c	(working copy)
@@ -224,10 +224,8 @@
 		ast_copy_string(host, current->host, hostlen);
 		*port = current->port;
 		ast_free(current);
-		if (option_verbose > 3) {
-			ast_verbose(VERBOSE_PREFIX_3 "ast_get_srv: SRV lookup for '%s' mapped to host %s, port %d\n",
+		ast_verb(3, "ast_get_srv: SRV lookup for '%s' mapped to host %s, port %d\n",
 				    service, host, *port);
-		}
 	} else {
 		host[0] = '\0';
 		*port = -1;
Index: res/res_features.c
===================================================================
--- res/res_features.c	(revision 92855)
+++ res/res_features.c	(working copy)
@@ -765,8 +765,7 @@
 	// This means a mixmonitor is attached to the channel, running or not is unknown.
 	if (count > 0) {
 		
-		if (option_verbose > 3)
-			ast_verbose(VERBOSE_PREFIX_3 "User hit '%s' to stop recording call.\n", code);
+		ast_verb(3, "User hit '%s' to stop recording call.\n", code);
 
 		//Make sure they are running
 		ast_channel_lock(callee_chan);
@@ -821,8 +820,7 @@
 				args[x] = '-';
 		}
 
-		if (option_verbose > 3)
-			ast_verbose(VERBOSE_PREFIX_3 "User hit '%s' to record call. filename: %s\n", code, touch_filename);
+		ast_verb(3, "User hit '%s' to record call. filename: %s\n", code, touch_filename);
 
 		pbx_exec(callee_chan, mixmonitor_app, args);
 		pbx_builtin_setvar_helper(callee_chan, "TOUCH_MIXMONITOR_OUTPUT", touch_filename);
@@ -945,8 +943,7 @@
 		}
 		if (!transferee->pbx) {
 			/* Doh!  Use our handy async_goto functions */
-			if (option_verbose > 2) 
-				ast_verbose(VERBOSE_PREFIX_3 "Transferring %s to '%s' (context %s) priority 1\n"
+			ast_verb(3, "Transferring %s to '%s' (context %s) priority 1\n"
 								,transferee->name, xferto, transferer_real_context);
 			if (ast_async_goto(transferee, transferer_real_context, xferto, 1))
 				ast_log(LOG_WARNING, "Async goto failed :-(\n");
Index: res/snmp/agent.c
===================================================================
--- res/snmp/agent.c	(revision 92855)
+++ res/snmp/agent.c	(working copy)
@@ -145,7 +145,7 @@
 
 void *agent_thread(void *arg)
 {
-	ast_verbose(VERBOSE_PREFIX_2 "Starting %sAgent\n", res_snmp_agentx_subagent ? "Sub" : "");
+	ast_verb(2, "Starting %sAgent\n", res_snmp_agentx_subagent ? "Sub" : "");
 
 	snmp_enable_stderrlog();
 
@@ -168,7 +168,7 @@
 
 	snmp_shutdown("asterisk");
 
-	ast_verbose(VERBOSE_PREFIX_2 "Terminating %sAgent\n",
+	ast_verb(2, "Terminating %sAgent\n",
 				res_snmp_agentx_subagent ? "Sub" : "");
 
 	return NULL;